]> git.proxmox.com Git - mirror_ovs.git/blob - debian/openvswitch-switch.init
debian: Upgrade database before starting ovsdb-server.
[mirror_ovs.git] / debian / openvswitch-switch.init
1 #! /bin/sh
2 #
3 # /etc/init.d/openvswitch-switch
4 #
5 # Written by Miquel van Smoorenburg <miquels@cistron.nl>.
6 # Modified for Debian by Ian Murdock <imurdock@gnu.ai.mit.edu>.
7 # Further changes by Javier Fernandez-Sanguino <jfs@debian.org>
8 # Modified for openvswitch-switch.
9 #
10 # Version: @(#)skeleton 1.9 26-Feb-2001 miquels@cistron.nl
11 #
12 ### BEGIN INIT INFO
13 # Provides: openvswitch-switch
14 # Required-Start: $network $named $remote_fs $syslog
15 # Required-Stop:
16 # Default-Start: 2 3 4 5
17 # Default-Stop: 0 1 6
18 # Short-Description: Open vSwitch switch
19 ### END INIT INFO
20
21 PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
22 ovs_vswitchd=/usr/sbin/ovs-vswitchd
23 ovsdb_server=/usr/bin/ovsdb-server
24
25 (test -x $ovsdb_server && test -x $ovs_vswitchd) || exit 0
26
27 DODTIME=1 # Time to wait for the server to die, in seconds
28 # If this value is set too low you might not
29 # let some servers to die gracefully and
30 # 'restart' will not work
31
32 # Include ovs-openflowd defaults if available
33 unset OVSDB_SERVER_OPTS
34 unset OVS_VSWITCHD_OPTS
35 unset CORE_LIMIT
36 unset ENABLE_MONITOR
37 default=/etc/default/openvswitch-switch
38 if [ -f $default ] ; then
39 . $default
40 fi
41
42 : ${ENABLE_MONITOR:=y}
43
44 set -e
45
46 # running_pid pid name
47 #
48 # Check if 'pid' is a process named 'name'
49 running_pid()
50 {
51 local pid=$1 name=$2
52 [ -z "$pid" ] && return 1
53 [ ! -d /proc/$pid ] && return 1
54 cmd=`cat /proc/$pid/cmdline | tr "\000" "\n"|head -n 1 |cut -d : -f 1`
55 # Is this the expected child?
56 case $cmd in
57 $name|*/$name)
58 return 0
59 ;;
60 *)
61 return 1
62 ;;
63 esac
64 }
65
66 # running name
67 #
68 # Checks for a running process named 'name' by looking for a pidfile
69 # named /var/run/${name}.pid
70 running()
71 {
72 local name=$1
73 local pidfile=/var/run/${name}.pid
74
75 # No pidfile, probably no daemon present
76 [ ! -f "$pidfile" ] && return 1
77
78 # Obtain the pid and check it against the binary name
79 pid=`cat $pidfile`
80 running_pid $pid $name || return 1
81 return 0
82 }
83
84 # force_stop name
85 #
86 # Checks for a running process named 'name', by looking for a pidfile
87 # named /var/run/${name}.pid, and then kills it and waits for it to
88 # die.
89 force_stop() {
90 local name=$1
91 local pidfile=/var/run/${name}.pid
92
93 [ ! -f "$pidfile" ] && return
94 if running $name; then
95 kill $pid
96 [ -n "$DODTIME" ] && sleep "$DODTIME"s
97 if running $name; then
98 kill -KILL $pid
99 [ -n "$DODTIME" ] && sleep "$DODTIME"s
100 if running $name; then
101 echo "Cannot kill $name (pid=$pid)!"
102 exit 1
103 fi
104 fi
105 fi
106 rm -f $pidfile
107 return 0
108 }
109
110 must_succeed() {
111 echo -n "$1: "
112 shift
113 if "$@"; then
114 echo "success."
115 else
116 echo " ERROR."
117 exit 1
118 fi
119 }
120
121 check_op() {
122 echo -n "$1: "
123 shift
124 if "$@"; then
125 echo "success."
126 else
127 echo " ERROR."
128 fi
129 }
130
131 # is_module_loaded module
132 #
133 # Returns 0 if 'module' is loaded, 1 otherwise.
134
135 is_module_loaded() {
136 local module=$1
137 grep -q "^$module " /proc/modules
138 }
139
140 # load_module module
141 #
142 # Loads 'module' into the running kernel, if it is not already loaded.
143 load_module() {
144 local module=$1
145 echo -n "Loading $module: "
146 if is_module_loaded $module; then
147 echo "already loaded, nothing to do."
148 elif modprobe $module; then
149 echo "success."
150 else
151 echo "ERROR."
152 echo "$module has probably not been built for this kernel."
153 if ! test -d /usr/share/doc/openvswitch-datapath-source; then
154 echo "Install the openvswitch-datapath-source package, then read"
155 echo "/usr/share/doc/openvswitch-datapath-source/README.Debian"
156 else
157 echo "For instructions, read"
158 echo "/usr/share/doc/openvswitch-datapath-source/README.Debian"
159 fi
160 exit 1
161 fi
162 }
163
164 # unload_module module
165 #
166 # Unloads 'module' from the running kernel, if it is loaded.
167 unload_module() {
168 local module=$1
169 echo -n "Unloading $module: "
170 if is_module_loaded $module; then
171 if rmmod $module; then
172 echo "success."
173 else
174 echo "ERROR."
175 exit 1
176 fi
177 else
178 echo "not loaded, nothing to do."
179 fi
180 }
181
182 unload_modules() {
183 if is_module_loaded openvswitch_mod; then
184 for dp in $(ovs-dpctl dump-dps); do
185 echo -n "Deleting datapath $dp: "
186 if ovs-dpctl del-dp $dp; then
187 echo "success."
188 else
189 echo "ERROR."
190 fi
191 done
192 fi
193 unload_module openvswitch_mod
194 unload_module ip_gre_mod
195 }
196
197 case "$1" in
198 start)
199 load_module openvswitch_mod
200 unload_module ip_gre
201 load_module ip_gre_mod
202
203 if test -n "$CORE_LIMIT"; then
204 check_op "Setting core limit to $CORE_LIMIT" ulimit -c "$CORE_LIMIT"
205 fi
206
207 # Create an empty configuration database if it doesn't exist.
208 if test ! -e /etc/openvswitch-switch/conf; then
209 # Create configuration database.
210 ovsdb-tool -vANY:console:emer \
211 create /etc/openvswitch-switch/conf \
212 /usr/share/openvswitch/vswitch.ovsschema
213 else
214 # Upgrade or downgrade schema and compact database.
215 ovsdb-tool -vANY:console:emer \
216 convert /etc/openvswitch-switch/conf \
217 /usr/share/openvswitch/vswitch.ovsschema
218 fi
219
220 if test "$ENABLE_MONITOR" = y; then
221 monitor_opt=--monitor
222 else
223 monitor_opt=
224 fi
225
226 # Start ovsdb-server.
227 set --
228 set -- "$@" --verbose=ANY:console:emer --verbose=ANY:syslog:err
229 set -- "$@" --log-file
230 set -- "$@" --detach --pidfile $monitor_opt
231 set -- "$@" --remote punix:/var/run/ovsdb-server
232 set -- "$@" /etc/openvswitch-switch/conf
233 set -- "$@" $OVSDB_SERVER_OPTS
234 echo -n "Starting ovsdb-server: "
235 start-stop-daemon --start --quiet --pidfile /var/run/ovsdb-server.pid \
236 --exec $ovsdb_server -- "$@"
237 if running ovsdb-server; then
238 echo "ovsdb-server."
239 else
240 echo " ERROR."
241 fi
242
243 ovs-vsctl --no-wait init
244
245 # Start ovs-vswitchd.
246 set --
247 set -- "$@" --verbose=ANY:console:emer --verbose=ANY:syslog:err
248 set -- "$@" --log-file
249 set -- "$@" --detach --pidfile $monitor_opt
250 set -- "$@" unix:/var/run/ovsdb-server
251 set -- "$@" $OVS_VSWITCHD_OPTS
252 echo -n "Starting ovs-vswitchd: "
253 start-stop-daemon --start --quiet --pidfile /var/run/ovs-vswitchd.pid \
254 --exec $ovs_vswitchd -- "$@"
255 if running ovs-vswitchd; then
256 echo "ovs-vswitchd."
257 else
258 echo " ERROR."
259 fi
260 ;;
261 stop)
262 echo -n "Stopping ovs-vswitchd: "
263 start-stop-daemon --stop --quiet --oknodo \
264 --pidfile /var/run/ovs-vswitchd.pid \
265 --exec $ovs_vswitchd
266 echo "ovs-vswitchd."
267
268 echo -n "Stopping ovsdb-server: "
269 start-stop-daemon --stop --quiet --oknodo \
270 --pidfile /var/run/ovsdb-server.pid \
271 --exec $ovsdb_server
272 echo "ovsdb-server."
273 ;;
274 force-stop)
275 echo -n "Forcefully stopping ovs-vswitchd: "
276 force_stop ovs-vswitchd
277 if ! running ovs-vswitchd; then
278 echo "ovs-vswitchd."
279 else
280 echo " ERROR."
281 fi
282
283 echo -n "Forcefully stopping ovsdb-server: "
284 force_stop ovsdb-server
285 if ! running ovsdb-server; then
286 echo "ovsdb-server."
287 else
288 echo " ERROR."
289 fi
290 ;;
291 unload)
292 unload_modules
293 ;;
294 reload)
295 ;;
296 force-reload)
297 # Nothing to do, since ovs-vswitchd automatically reloads
298 # whenever its configuration changes, and ovsdb-server doesn't
299 # have anything to reload.
300 ;;
301 restart)
302 $0 stop || true
303 $0 start
304 ;;
305 status)
306 for daemon in ovs-vswitchd ovsdb-server; do
307 echo -n "$daemon is "
308 if running $daemon; then
309 echo "running"
310 else
311 echo " not running."
312 exit 1
313 fi
314 done
315 ;;
316 *)
317 N=/etc/init.d/$NAME
318 echo "Usage: $N {start|stop|restart|force-reload|status|force-stop|unload}" >&2
319 exit 1
320 ;;
321 esac
322
323 exit 0